/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.cpu.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.cpu.shared.Shared.*;

public final class JZ extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         JZ.class,
         "JZ",
         true,
         new ArgumentDecls()
             .add("source", ArgumentMode.IN, OPRNDL.INFO)
             .add("target", INDEX),
         true,
         true,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final AddressingMode source = (AddressingMode) getArgument("source", args);
      final Immediate target = (Immediate) getArgument("target", args);

      return new JZ(source, target);
    }
  }

  public static final IInfo INFO = new Info();

  public final AddressingMode source;
  public final Immediate target;

  public JZ(final AddressingMode source, final Immediate target) {
    assert OPRNDL.INFO.isSupported(source);
    assert INDEX.equals(target.getType());
    this.source = source;
    this.target = target;
  }

  @Override
  public String syntax() {
    return String.format("jz <label>%d", target.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("111%b", target.access().load().toBinString());
  }

  @Override
  public void action() {
    if (source.access().load().equals(Data.valueOf(BYTE, 0x0))) {
      PC.access().store(target.access().load());
    }
  }
}
