/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class addiu extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         addiu.class,
         "addiu",
         false,
         new ArgumentDecls()
             .add("rt", ArgumentMode.OUT, REG.INFO)
             .add("rs", ArgumentMode.IN, REG.INFO)
             .add("imm", SHORT),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final REG rs = (REG) getArgument("rs", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new addiu(rt, rs, imm);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "addiu",
          true,
          new ArgumentDecls()
              .add("rt", ArgumentMode.OUT, REG.INFO)
              .add("rs", ArgumentMode.IN, REG.INFO)
              .add("imm", SHORT),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rt = (REG) getArgument("rt", args);
      final REG rs = (REG) getArgument("rs", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new addiu(
          rt,
          rs,
          imm
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final REG rt;
  public final REG rs;
  public final Immediate imm;

  public addiu(final REG rt, final REG rs, final Immediate imm) {
    assert REG.INFO.isSupported(rt);
    assert REG.INFO.isSupported(rs);
    assert SHORT.equals(imm.getType());
    this.rt = rt;
    this.rs = rs;
    this.imm = imm;
  }

  @Override
  public String syntax() {
    return String.format("addiu %s, %s, 0x%x", rt.syntax(), rs.syntax(), imm.access().load().bigIntegerValue(false));
  }

  @Override
  public String image() {
    return String.format("000000%s%s%s", rs.image(), rt.image(), imm.access().load().toString());
  }

  @Override
  public void action() {
    rt.access().store(rs.access().load().add(Data.signExtend(Type.INT(32), imm.access().load())));
  }
}
