/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class jalr extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         jalr.class,
         "jalr",
         false,
         new ArgumentDecls()
             .add("rd", ArgumentMode.OUT, REG.INFO)
             .add("rs", ArgumentMode.IN, REG.INFO),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rs = (REG) getArgument("rs", args);

      return new jalr(rd, rs);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "jalr",
          true,
          new ArgumentDecls()
              .add("rd", ArgumentMode.OUT, REG.INFO)
              .add("rs", ArgumentMode.IN, REG.INFO),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rs = (REG) getArgument("rs", args);

      return new instruction(
        new jalr(
          rd,
          rs
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final REG rd;
  public final REG rs;

  public jalr(final REG rd, final REG rs) {
    assert REG.INFO.isSupported(rd);
    assert REG.INFO.isSupported(rs);
    this.rd = rd;
    this.rs = rs;
  }

  @Override
  public String syntax() {
    return String.format("jalr %s, %s", rs.syntax(), rd.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%s00000%s00000001001", rs.image(), rd.image());
  }

  @Override
  public void action() {
    rd.access().store(CIA.access().load().add(Data.valueOf(WORD, 0x4)).add(Data.valueOf(WORD, 0x4)));
    BRANCH.access().store(Data.valueOf(BIT, 0x1));
    JMPADDR.access().store(rs.access().load());
  }
}
