/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw;

import ru.ispras.microtesk.model.api.ProcessorModel;
import ru.ispras.microtesk.model.api.metadata.MetaModelPrinter;
import ru.ispras.microtesk.model.api.state.ModelStatePrinter;
import ru.ispras.microtesk.model.api.instruction.AddressingMode;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.vliw.op.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class Model extends ProcessorModel {
  public static final String NAME = "vliw";

  private static final AddressingMode.IInfo[] __MODES = new AddressingMode.IInfo[] {
    R.INFO,
    F.INFO
  };

  private static final AddressingMode.IInfo[] __MODE_GROUPS = new AddressingMode.IInfo[] {
  };

  private static final Operation.IInfo[] __OPS = new Operation.IInfo[] {
    NOP.INFO,
    ADD.INFO,
    ADDI.INFO,
    SUB.INFO,
    MUL.INFO,
    SLL.INFO,
    SRL.INFO,
    MOVN.INFO,
    MOVZ.INFO,
    MOVE.INFO,
    AND.INFO,
    OR.INFO,
    XOR.INFO,
    SLT.INFO,
    SLTI.INFO,
    LUI.INFO,
    LW.INFO,
    SW.INFO,
    B.INFO,
    BEQ.INFO,
    BNE.INFO,
    ADD_S.INFO,
    SUB_S.INFO,
    MUL_S.INFO,
    NEG_S.INFO,
    ABS_S.INFO,
    C_EQ_S.INFO,
    C_LT_S.INFO,
    C_LE_S.INFO,
    MOV_S.INFO,
    MTF.INFO,
    MFF.INFO,
    MOVT_S.INFO,
    MOVF_S.INFO,
    MOVN_S.INFO,
    MOVZ_S.INFO,
    BFF.INFO,
    BFT.INFO,
    vliw.INFO
  };

  private static final Operation.IInfo[] __OP_GROUPS = new Operation.IInfo[] {
    ALU.INFO,
    LoadStore.INFO,
    Branch.INFO,
    FP.INFO,
    FPBranch.INFO,
    channel1.INFO,
    channel2.INFO,
    instruction.INFO
  };

  public Model() {
    super(
        NAME,
        __MODES,
        __MODE_GROUPS,
        __OPS,
        __OP_GROUPS,
        __REGISTERS,
        __MEMORY,
        __VARIABLES,
        __LABELS
        );
  }

  public static void printInformation() {
    final Model model = new Model();

    final MetaModelPrinter metaModelPrinter = new MetaModelPrinter(model.getMetaData());
    metaModelPrinter.printAll();

    final ModelStatePrinter modelStatePrinter = new ModelStatePrinter(model);
    modelStatePrinter.printRegisters();
  }

  public static void main(String[] args) {
    printInformation();
  }
}
 