/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class R extends AddressingMode {
  public static final String NAME = "R";

  private static final class Info extends InfoAndRule {
    Info() {
      super(
          R.class,
          "R",
          WORD,
          new ArgumentDecls()
              .add("i", INDEX),
          false,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public AddressingMode create(final Map<String, Primitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      return new R(i);
    }
  }

  public static final IInfo INFO = new Info();

  public final Immediate i;

  public R(final Immediate i) {
    this.i = i;
  }

  @Override
  public String syntax() {
    return String.format("%d", i.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("%5b", i.access().load().toBinString());
  }

  @Override
  public void action() {
    if (i.access().load().equals(Data.valueOf(INDEX, 0x0))) {
      GPR.access(i.access().load()).store(Data.valueOf(WORD, 0x0));
    }
  }

  @Override
  public Location access() {
    return GPR.access(i.access().load()).setName(syntax());
  }
}
 