/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class ADD extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         ADD.class,
         "ADD",
         false,
         new ArgumentDecls()
             .add("rd", ArgumentMode.OUT, R.INFO)
             .add("rs", ArgumentMode.IN, R.INFO)
             .add("rt", ArgumentMode.IN, R.INFO),
         false,
         false,
         true,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rd = (R) getArgument("rd", args);
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);

      return new ADD(rd, rs, rt);
    }
  }

  public static final IInfo INFO = new Info();

  public final R rd;
  public final R rs;
  public final R rt;

  public ADD(final R rd, final R rs, final R rt) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);
    this.rd = rd;
    this.rs = rs;
    this.rt = rt;
  }

  @Override
  public String syntax() {
    return String.format("ADD %s, %s, %s", rd.syntax(), rs.syntax(), rt.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%s%s%s00000100000", rs.image(), rt.image(), rd.image());
  }

  @Override
  public void action() {
    temp.access().store(Location.concat(rs.access(), rs.access().bitField(31, 31)).load().add(Location.concat(rt.access(), rt.access().bitField(31, 31)).load()));
    if (!temp.access().bitField(32, 32).load().equals(temp.access().bitField(31, 31).load())) {
      Execution.exception("IntegerOverflow");
    } else {
      rd.access().store(temp.access().bitField(31, 0).load());
    }
  }
}
