/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class ADDI extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         ADDI.class,
         "ADDI",
         false,
         new ArgumentDecls()
             .add("rt", ArgumentMode.OUT, R.INFO)
             .add("rs", ArgumentMode.IN, R.INFO)
             .add("imm", SHORT),
         false,
         false,
         true,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new ADDI(rt, rs, imm);
    }
  }

  public static final IInfo INFO = new Info();

  public final R rt;
  public final R rs;
  public final Immediate imm;

  public ADDI(final R rt, final R rs, final Immediate imm) {
    assert R.INFO.isSupported(rt);
    assert R.INFO.isSupported(rs);
    assert SHORT.equals(imm.getType());
    this.rt = rt;
    this.rs = rs;
    this.imm = imm;
  }

  @Override
  public String syntax() {
    return String.format("ADDI %s, %s, 0x%x", rt.syntax(), rs.syntax(), imm.access().load().bigIntegerValue(false));
  }

  @Override
  public String image() {
    return String.format("001000%s%s%s", rs.image(), rt.image(), imm.access().load().toString());
  }

  @Override
  public void action() {
    temp.access().store(Location.concat(rs.access(), rs.access().bitField(31, 31)).load().add(Data.signExtend(Type.INT(33), imm.access().load())));
    if (!temp.access().bitField(32, 32).load().equals(temp.access().bitField(31, 31).load())) {
      Execution.exception("IntegerOverflow");
    } else {
      rt.access().store(temp.access().bitField(31, 0).load());
    }
  }
}
