/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class LUI extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         LUI.class,
         "LUI",
         false,
         new ArgumentDecls()
             .add("rt", ArgumentMode.OUT, R.INFO)
             .add("offset", SHORT),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new LUI(rt, offset);
    }
  }

  public static final IInfo INFO = new Info();

  public final R rt;
  public final Immediate offset;

  public LUI(final R rt, final Immediate offset) {
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());
    this.rt = rt;
    this.offset = offset;
  }

  @Override
  public String syntax() {
    return String.format("LUI %s, 0x%x", rt.syntax(), offset.access().load().bigIntegerValue(false));
  }

  @Override
  public String image() {
    return String.format("00111100000%s%s", rt.image(), offset.access().load().toString());
  }

  @Override
  public void action() {
    rt.access().store(Data.signExtend(WORD, offset.access().load()).shiftLeft(Data.valueOf(WORD, 0x10)));
  }
}
