/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MOVF_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MOVF_S.class,
         "MOVF_S",
         false,
         new ArgumentDecls()
             .add("fd", ArgumentMode.OUT, F.INFO)
             .add("fs", ArgumentMode.IN, F.INFO)
             .add("cc", COND_CODE),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final F fd = (F) getArgument("fd", args);
      final F fs = (F) getArgument("fs", args);
      final Immediate cc = (Immediate) getArgument("cc", args);

      return new MOVF_S(fd, fs, cc);
    }
  }

  public static final IInfo INFO = new Info();

  public final F fd;
  public final F fs;
  public final Immediate cc;

  public MOVF_S(final F fd, final F fs, final Immediate cc) {
    assert F.INFO.isSupported(fd);
    assert F.INFO.isSupported(fs);
    assert COND_CODE.equals(cc.getType());
    this.fd = fd;
    this.fs = fs;
    this.cc = cc;
  }

  @Override
  public String syntax() {
    return String.format("MOVF_S %s, %s, %d", fd.syntax(), fs.syntax(), cc.access().load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("01000110000%s00%s%s010001", cc.access().load().toString(), fs.image(), fd.image());
  }

  @Override
  public void action() {
    if (FCCR.access().bitField(cc.access().load(), cc.access().load()).load().equals(Data.valueOf(Type.INT(1), 0x0))) {
      fd.access().store(fs.access().load());
    }
  }
}
