/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class MOVN_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MOVN_S.class,
         "MOVN_S",
         false,
         new ArgumentDecls()
             .add("fd", ArgumentMode.OUT, F.INFO)
             .add("fs", ArgumentMode.IN, F.INFO)
             .add("rt", ArgumentMode.IN, R.INFO),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final F fd = (F) getArgument("fd", args);
      final F fs = (F) getArgument("fs", args);
      final R rt = (R) getArgument("rt", args);

      return new MOVN_S(fd, fs, rt);
    }
  }

  public static final IInfo INFO = new Info();

  public final F fd;
  public final F fs;
  public final R rt;

  public MOVN_S(final F fd, final F fs, final R rt) {
    assert F.INFO.isSupported(fd);
    assert F.INFO.isSupported(fs);
    assert R.INFO.isSupported(rt);
    this.fd = fd;
    this.fs = fs;
    this.rt = rt;
  }

  @Override
  public String syntax() {
    return String.format("MOVN_S %s, %s, %s", fd.syntax(), fs.syntax(), rt.syntax());
  }

  @Override
  public String image() {
    return String.format("01000110000%s%s%s010011", rt.image(), fs.image(), fd.image());
  }

  @Override
  public void action() {
    if (!rt.access().load().equals(Data.valueOf(WORD, 0x0))) {
      fd.access().store(fs.access().load());
    }
  }
}
